// CurrentSource

import java.awt.*;
import java.awt.geom.*;

public class CurrentSource  {
	String name;
	int n1, n2;
	double value;
	double xpos, ypos;
	double angle, phi;
	Color color;

    CurrentSource()
    {
	color = Color.BLACK;
	xpos = 0.0;
	ypos = 0.0;
	angle = 0.0;
	
    }

    CurrentSource(String [] tokens) {
	if (tokens.length>4) {
		name = tokens[1];
		n1 = Integer.parseInt(tokens[2]);
		n2 = Integer.parseInt(tokens[3]);
		value = Double.parseDouble(tokens[4]);
	}
	if (tokens.length>6) {
		xpos = Double.parseDouble(tokens[5]);
		ypos = Double.parseDouble(tokens[6]);
	}
	if (tokens.length>7) setAngle(Double.parseDouble(tokens[7]));
   }

   public String toString() {
	return "I " + name + " " + n1 + " " + n2 + " " + value;
   }


    public void setAngle(double angle)
    {
	this.angle = angle;
	phi = angle*Math.PI/180.0;

    }

   public void setPosition(double x, double y) {
	xpos = x;
	ypos = y;
   }

   public void draw(Graphics g) {
	double scl = 0.1;
	Graphics2D g2 = (Graphics2D) g;
	Stroke saveStroke = g2.getStroke();
	AffineTransform saveXform = g2.getTransform();
	// use minus sign to switch to book/image coordinate system
	g2.translate(xpos,-ypos);
	g2.rotate(-phi);
	g2.scale(scl,scl);
	g2.setStroke(new BasicStroke(0.25f,BasicStroke.CAP_ROUND,BasicStroke.JOIN_ROUND));
	Paint savePaint = g2.getPaint();
	g2.setPaint(color);
	Line2D line = new Line2D.Double(0.0,-3.0,0.0,3.0);
	g2.draw(line);
	Ellipse2D circ = new Ellipse2D.Double(-2.5,-2.5,5.0,5.0);
	g2.setPaint(Color.WHITE);
	g2.fill(circ);
	g2.setPaint(color);
	g2.draw(circ);
	GeneralPath p1 = new GeneralPath();
	p1.moveTo(0.0,-2.0);
	p1.lineTo(0.0, 2.0);
	g2.draw(p1);
	GeneralPath p2 = new GeneralPath();
	p2.moveTo( 0.0,-2.0);
	p2.lineTo(-0.7,0.0);
	p2.lineTo( 0.0,-0.8);
	p2.lineTo( 0.7,0.0);
	p2.closePath();
	g2.fill(p2);
	
	g2.setStroke(saveStroke);
	g2.setPaint(savePaint);
	g2.setTransform(saveXform);
  }
}
